unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    DACTrack0: TTrackBar;
    DACTrack1: TTrackBar;
    DACTrack2: TTrackBar;
    DACTrack3: TTrackBar;
    DACTrack4: TTrackBar;
    DACTrack5: TTrackBar;
    DACTrack6: TTrackBar;
    DACTrack7: TTrackBar;
    DACLabel0: TLabel;
    DACLabel1: TLabel;
    DACLabel2: TLabel;
    DACLabel3: TLabel;
    DACLabel4: TLabel;
    DACLabel5: TLabel;
    DACLabel6: TLabel;
    DACLabel7: TLabel;
    AutoCheck: TCheckBox;
    UpdateButton: TButton;
    ChLabel0: TLabel;
    ChLabel1: TLabel;
    ChLabel2: TLabel;
    ChLabel3: TLabel;
    ChLabel4: TLabel;
    ChLabel5: TLabel;
    ChLabel6: TLabel;
    ChLabel7: TLabel;
    updateDEF: TButton;
    procedure FormCreate(Sender: TObject);
    procedure DACTrackChange(Sender: TObject);
    procedure AutoCheckClick(Sender: TObject);
    procedure UpdateButtonClick(Sender: TObject);
    procedure updateDEFClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  AIOUSB, DetectUnit;

type
  TDACChange = packed record
    Channel,
    Counts: Word;
  end;

var
  DeviceIndex: LongWord;
  DACTrack: array[0..7] of TTrackBar;
  DACLabel: array[0..7] of TLabel;
  bAuto: Boolean = True;
  Changes: array of TDACChange;

procedure TForm1.FormCreate(Sender: TObject);
var
  DetectForm: TDetectForm;
  I: Integer;
  Status: LongWord;
  PID: LongWord;

begin
  DeviceIndex := diOnly;

  
  for I := 0 to 7 do
    DACDirect(DeviceIndex, I, $000)
  ;

  Handle;

  Constraints.MaxHeight := Height;
  Constraints.MinHeight := Height;

  DACTrack[0] := DACTrack0;
  DACTrack[1] := DACTrack1;
  DACTrack[2] := DACTrack2;
  DACTrack[3] := DACTrack3;
  DACTrack[4] := DACTrack4;
  DACTrack[5] := DACTrack5;
  DACTrack[6] := DACTrack6;
  DACTrack[7] := DACTrack7;

  DACLabel[0] := DACLabel0;
  DACLabel[1] := DACLabel1;
  DACLabel[2] := DACLabel2;
  DACLabel[3] := DACLabel3;
  DACLabel[4] := DACLabel4;
  DACLabel[5] := DACLabel5;
  DACLabel[6] := DACLabel6;
  DACLabel[7] := DACLabel7;
end;

procedure TForm1.DACTrackChange(Sender: TObject);
var
  I, J, L: Integer;
  Counts: Word;

begin
  I := (Sender as TControl).Tag;

  Counts := DACTrack[I].Position;

  DACLabel[I].Caption := IntToHex(Counts, 3);
  DACLabel[I].Color := $008000;
  DACLabel[I].Font.Color := $FFFFFF;

  if bAuto then begin
    DACDirect(DeviceIndex, I, Counts);
    DACLabel[I].ParentColor := True;
    DACLabel[I].ParentFont := True;
  end
  else begin
    L := Length(Changes);
    for J := 0 to L - 1 do
      if Changes[J].Channel = I then begin
        Changes[J].Counts := Counts;
        Exit;
      end
    ;
    SetLength(Changes, L + 1);
    Changes[L].Channel := I;
    Changes[L].Counts := Counts;
  end;
end;

procedure TForm1.AutoCheckClick(Sender: TObject);
begin
  if UpdateButton.Enabled and (Length(Changes) <> 0) then UpdateButton.Click;
  bAuto := AutoCheck.Checked;
  UpdateButton.Enabled := not bAuto;
end;

procedure TForm1.UpdateButtonClick(Sender: TObject);
var
  I: Integer;

begin
  if Length(Changes) <> 0 then begin
    DACMultiDirect(DeviceIndex, @Changes[0], Length(Changes));
    for I := 0 to High(Changes) do begin
      DACLabel[Changes[I].Channel].ParentColor := True;
      DACLabel[Changes[I].Channel].ParentFont := True;
    end;
    SetLength(Changes, 0);
  end;
end;

procedure TForm1.updateDEFClick(Sender: TObject);
type
   IOStruct = packed record
     dac: array[0..7] of word;
     dacrange: byte;
   end;
   DefStruct = packed record
     gtickdiv: word;
     wdgsec: word;
     DEF: IOStruct;
     WDG: IOStruct;
   end;

var
   DEFbuf : DefStruct;
   I : Integer;
begin
  for I := 0 to 7 do begin
    DEFBuf.DEF.dac[I] := DACTrack[I].Position; // 0..4095 counts to set as default
    DEFBuf.WDG.dac[I] := DACTrack[I].Position;
  end;
  DEFBuf.DEF.dacrange := 0; // set to other than -1 to prove you've init
  DEFBUF.WDG.dacrange := 0;
  DEFBuf.gtickdiv := 0; // turn off Global Tick (only used for DIO, which this board has none of)
  DEFBuf.wdgsec := 0; // turn off WDG

  GenericVendorWrite( diOnly, $3C, 0, $0023, sizeof(DEFBuf), @DEFbuf );  // write DEFBuf to SRAM
  GenericVendorWrite( diOnly, $3C, $ACCE, $0010, 0, nil);
end;

end.
